-- Need to call the custom attribute store procedure to drop the staging table. 
-- By this time the procedure is already loaded.
BEGIN
  DECLARE @vSQL LONG VARCHAR;
  DECLARE @vStagingTableName VARCHAR(1024);
  DECLARE @vStagingColExists INTEGER;   


FOR AttributesLOOP as AttributesCUR dynamic scroll cursor for
      select CUSTOM_ATTRIBUTE_KEY as CUSTOM_ATTRIBUTE_KEY_R,
        CUSTOM_ATTRIBUTE_CONTEXT as CUSTOM_ATTRIBUTE_CONTEXT_R,
        TYPE as TYPE_R,
        DISPLAY_NAME as DISPLAY_NAME_R,
        COLUMN_NAME as COLUMN_NAME_R,
        COLUMN_TYPE as COLUMN_TYPE_R,
        SOURCE_NAME as SOURCE_NAME_R    
      from SAHARA.CUSTOM_ATTRIBUTE CONFIGURED
      where CONFIGURED.SOURCE_NAME not in ('ORGANIZATION_BE','APPLICATION_BE', 'ORGANIZATION_COMPOSITE_BE','APPLICATION_COMPOSITE_BE','BUSINESSENTITY')
	    and exists (select 1
                         from SAHARA.P_CUSTOM_ATTRIBUTE PUBLISHED
                        where PUBLISHED.CUSTOM_ATTRIBUTE_KEY =
                              CONFIGURED.CUSTOM_ATTRIBUTE_KEY)
     DO            

            set @vStagingTableName = CUSTOM_ATTRIBUTE_CONTEXT_R || '_';

    
                select SAHARA.fn_HELPER_ColumnExists('SAHARA_APP',@vStagingTableName,COLUMN_NAME_R) into 
                        @vStagingColExists ;

                if @vStagingColExists = 1 then        
                    SET @vSQL = 'lock table ' ||
                    -- source table or view
                    'SAHARA_APP.' || CUSTOM_ATTRIBUTE_CONTEXT_R || '_ ' ||
                            'in exclusive mode';

                    EXECUTE IMMEDIATE @vSQL;
	                SET @vSQL = 'alter table SAHARA_APP.' || CUSTOM_ATTRIBUTE_CONTEXT_R ||
                        '_ drop  "' || COLUMN_NAME_R || '"';
                    EXECUTE IMMEDIATE @vSQL;                    
                end if;            
      COMMIT ;
     END FOR;
 END;

/* Sahara Tables*/

/* Table: DATABASE */
if exists (select 1 from sys.sysindexes where tname = 'DATABASES' and iname = 'I_DATABASES_ISBASEDONDBVM')
then
	drop index SAHARA.DATABASES.I_DATABASES_ISBASEDONDBVM;
end if;

if exists (select 1 from sys.syscolumns where tname='DATABASES' and cname='IS_BASED_ON_DB_VM') 
then
	ALTER TABLE SAHARA.DATABASES DROP IS_BASED_ON_DB_VM;
end if;

/* Table: DATABASE_ */
if exists (select 1 from sys.syscolumns where tname='DATABASES_' and cname='IS_BASED_ON_DB_VM') 
then
	ALTER TABLE SAHARA_APP.DATABASES_ DROP IS_BASED_ON_DB_VM;
end if;

/* Table: SAHARA.DATABASE_CAPACITY  */
if exists (select 1 from sys.syscolumns where tname='DATABASE_CAPACITY' and cname='CAPACITY_FROM_DB_VM') 
then
	ALTER TABLE SAHARA.DATABASE_CAPACITY DROP CAPACITY_FROM_DB_VM;
end if;

if exists (select 1 from sys.syscolumns where tname='DATABASE_CAPACITY' and cname='AVAILABLE_FROM_DB_VM') 
then
	ALTER TABLE SAHARA.DATABASE_CAPACITY DROP AVAILABLE_FROM_DB_VM;
end if;

if exists (select 1 from sys.syscolumns where tname='DATABASE_CAPACITY' and cname='USED_FROM_DB_VM') 
then
	ALTER TABLE SAHARA.DATABASE_CAPACITY DROP USED_FROM_DB_VM;
end if;

/* Table: DATABASE_CAPACITY_  */
if exists (select 1 from sys.syscolumns where tname='DATABASE_CAPACITY_' and cname='CAPACITY_FROM_DB_VM') 
then
	ALTER TABLE SAHARA_APP.DATABASE_CAPACITY_ DROP CAPACITY_FROM_DB_VM;
end if;

if exists (select 1 from sys.syscolumns where tname='DATABASE_CAPACITY_' and cname='AVAILABLE_FROM_DB_VM') 
then
	ALTER TABLE SAHARA_APP.DATABASE_CAPACITY_ DROP AVAILABLE_FROM_DB_VM;
end if;

if exists (select 1 from sys.syscolumns where tname='DATABASE_CAPACITY_' and cname='USED_FROM_DB_VM') 
then
	ALTER TABLE SAHARA_APP.DATABASE_CAPACITY_ DROP USED_FROM_DB_VM;
end if;

/* Table: DISKGROUP  */

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_SSDBCLSTRDDB')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_SSDBCLSTRDDB;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_REDUNDANCYTYPE')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_REDUNDANCYTYPE;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_USESVMVOLUMES')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_USESVMVOLUMES;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_ISBASEDONTHIN')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_ISBASEDONTHIN;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_ORGANIZATIONBE')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_ORGANIZATIONBE;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_PPLCTNCMPSTB')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_PPLCTNCMPSTB;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_RGNZTNCMPSTB')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_RGNZTNCMPSTB;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_SBSDNDRCTTTCHD')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_SBSDNDRCTTTCHD;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_STATE')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_STATE;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_T2SCRRNTT2SDLTDD')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_T2SCRRNTT2SDLTDD;
end if;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP' and iname = 'I_DISKGROUP_APPLICATIONBE')
then
	drop index SAHARA.DISKGROUP.I_DISKGROUP_APPLICATIONBE;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP' and cname='REDUNDANCY_TYPE') 
then
	ALTER TABLE SAHARA.DISKGROUP DROP REDUNDANCY_TYPE;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP' and cname='IS_USED_BY_CLUSTERED_DB') 
then
	ALTER TABLE SAHARA.DISKGROUP DROP IS_USED_BY_CLUSTERED_DB;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP' and cname='USES_VM_VOLUMES') 
then
	ALTER TABLE SAHARA.DISKGROUP DROP USES_VM_VOLUMES;
end if;

/* Table: SAHARA_APP.DISKGROUP_  */
if exists (select 1 from sys.syscolumns where tname='DISKGROUP_' and cname='REDUNDANCY_TYPE') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_ DROP REDUNDANCY_TYPE;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP_' and cname='IS_USED_BY_CLUSTERED_DB') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_ DROP IS_USED_BY_CLUSTERED_DB;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP_' and cname='USES_VM_VOLUMES') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_ DROP USES_VM_VOLUMES;
end if;

/* Table: SAHARA.DISKGROUP_CAPACITY  */
if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY' and cname='OVERHEAD_CAPACITY') 
then
	ALTER TABLE SAHARA.DISKGROUP_CAPACITY DROP OVERHEAD_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY' and cname='UNKNOWN_CAPACITY') 
then
	ALTER TABLE SAHARA.DISKGROUP_CAPACITY DROP UNKNOWN_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY' and cname='DB_USED_CAPACITY') 
then
	ALTER TABLE SAHARA.DISKGROUP_CAPACITY DROP DB_USED_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY' and cname='USED_CAPACITY_BY_CLUSTERED_DB') 
then
	ALTER TABLE SAHARA.DISKGROUP_CAPACITY DROP USED_CAPACITY_BY_CLUSTERED_DB;
end if;

/* Table: SAHARA_APP.DISKGROUP_CAPACITY_  */
if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY_' and cname='OVERHEAD_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_CAPACITY_ DROP OVERHEAD_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY_' and cname='UNKNOWN_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_CAPACITY_ DROP UNKNOWN_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY_' and cname='DB_USED_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_CAPACITY_ DROP DB_USED_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='DISKGROUP_CAPACITY_' and cname='USED_CAPACITY_BY_CLUSTERED_DB') 
then
	ALTER TABLE SAHARA_APP.DISKGROUP_CAPACITY_ DROP USED_CAPACITY_BY_CLUSTERED_DB;
end if;

/* Table: SAHARA.HOST_CAPACITY  */
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_USED_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_USED_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_FREE_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_FREE_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_OVERHEAD_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_OVERHEAD_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='APPS_ON_DB_VM_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP APPS_ON_DB_VM_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='APPS_ON_DB_VM_OTHER_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP APPS_ON_DB_VM_OTHER_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_DB_USED_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_DB_USED_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_DB_USED_OTHER_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_DB_USED_OTHER_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='DB_VM_UNKNOWN_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP DB_VM_UNKNOWN_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='ADJUSTED_DB_VM_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP ADJUSTED_DB_VM_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='ADJUSTED_DB_VM_USED_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP ADJUSTED_DB_VM_USED_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='ADJUSTED_DB_VM_FREE_CAPACITY') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP ADJUSTED_DB_VM_FREE_CAPACITY;
end if;

if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='ADJUSTED_DB_VM_OVERHEAD_CAP') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP ADJUSTED_DB_VM_OVERHEAD_CAP;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='ADJUSTED_APPS_ON_DB_VM_CAP') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP ADJUSTED_APPS_ON_DB_VM_CAP;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY' and cname='ADJUSTED_DB_VM_DB_USED_CAP') 
then
	ALTER TABLE SAHARA.HOST_CAPACITY DROP ADJUSTED_DB_VM_DB_USED_CAP;
end if;

/* Table SAHARA_APP.HOST_CAPACITY_ */
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_USED_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_USED_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_FREE_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_FREE_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_OVERHEAD_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_OVERHEAD_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='APPS_ON_DB_VM_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP APPS_ON_DB_VM_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='APPS_ON_DB_VM_OTHER_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP APPS_ON_DB_VM_OTHER_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_DB_USED_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_DB_USED_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_DB_USED_OTHER_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_DB_USED_OTHER_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='DB_VM_UNKNOWN_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP DB_VM_UNKNOWN_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='ADJUSTED_DB_VM_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP ADJUSTED_DB_VM_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='ADJUSTED_DB_VM_USED_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP ADJUSTED_DB_VM_USED_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='ADJUSTED_DB_VM_FREE_CAPACITY') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP ADJUSTED_DB_VM_FREE_CAPACITY;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='ADJUSTED_DB_VM_OVERHEAD_CAP') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP ADJUSTED_DB_VM_OVERHEAD_CAP;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='ADJUSTED_APPS_ON_DB_VM_CAP') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP ADJUSTED_APPS_ON_DB_VM_CAP;
end if;
if exists (select 1 from sys.syscolumns where tname='HOST_CAPACITY_' and cname='ADJUSTED_DB_VM_DB_USED_CAP') 
then
	ALTER TABLE SAHARA_APP.HOST_CAPACITY_ DROP ADJUSTED_DB_VM_DB_USED_CAP;
end if;

/* table SAHARA.VOLUME */
if exists (select 1 from sys.sysindexes where tname = 'VOLUME' and iname = 'I_VOLUME_ISUSEDBYDBVM')
then
	drop index SAHARA.VOLUME.I_VOLUME_ISUSEDBYDBVM;
end if;

if exists (select 1 from sys.sysindexes where tname = 'VOLUME' and iname = 'I_VOLUME_DBVMNAME')
then
	drop index SAHARA.VOLUME.I_VOLUME_DBVMNAME;
end if;

if exists (select 1 from sys.syscolumns where tname='VOLUME' and cname='IS_USED_BY_DB_VM') 
then
	ALTER TABLE SAHARA.VOLUME DROP IS_USED_BY_DB_VM;
end if;
if exists (select 1 from sys.syscolumns where tname='VOLUME' and cname='DB_VM_NAME') 
then
	ALTER TABLE SAHARA.VOLUME DROP DB_VM_NAME;
end if;

/* TABLE SAHARA_APP.VOLUME_  */

if exists (select 1 from sys.syscolumns where tname='VOLUME_' and cname='IS_USED_BY_DB_VM') 
then
	ALTER TABLE SAHARA_APP.VOLUME_ DROP IS_USED_BY_DB_VM;
end if;
if exists (select 1 from sys.syscolumns where tname='VOLUME_' and cname='DB_VM_NAME') 
then
	ALTER TABLE SAHARA_APP.VOLUME_ DROP DB_VM_NAME;
end if;

commit;

if exists (select 1 from sys.sysindexes where tname = 'DISKGROUP_BVIEW_NODE' and iname = 'I_DISKGROUP_BVIEWNODE_BVIEWKEY')
then
	drop index SAHARA.DISKGROUP_BVIEW_NODE.I_DISKGROUP_BVIEWNODE_BVIEWKEY;
end if;

if exists(select 1 from sys.systable where table_name='DISKGROUP_BVIEW_NODE' and creator=user_id('SAHARA'))
then
	drop table SAHARA.DISKGROUP_BVIEW_NODE;
end if;

if exists(select 1 from sys.systable where table_name='INSTALLED_ADDONS' and creator=user_id('SAHARA'))
then
	drop table SAHARA.INSTALLED_ADDONS;
end if;

/*Unconfigure BV IE*/

call SAHARA_APP.SP_DROP_('TABLE', 'IE_DISKGROUP_');

CALL SAHARA_APP.SP_DROP_('PROCEDURE','SP_IE_CorrelateObjectByObjectName');

CREATE PROCEDURE SAHARA_APP.SP_IE_CorrelateObjectByObjectName(IN @pType  VARCHAR(255))
BEGIN
  DECLARE @vSQL_TEMPLATE LONG VARCHAR;
  DECLARE @vSQL LONG VARCHAR;
  BEGIN 

    SET @vSQL_TEMPLATE ='begin FOR StageCursorLOOP AS StageCursor CURSOR FOR select HOST_NAME AS HOST_NAME_R, $TYPE$_NAME AS $TYPE$_NAME_R '||
                        ' from SAHARA_APP.IE_$TYPE$_ where HOST_NAME is not null ' ||
                   'and $TYPE$_NAME is not null and $TYPE$_KEY is null and BVIEW_NODE_KEY is not null for update of $TYPE$_KEY ' ||
                   'DO ' ||
                'update SAHARA_APP.IE_$TYPE$_ ' ||
                    'set $TYPE$_KEY = ' ||
                        '(select FIRST $TYPE$_KEY ' ||
                           'from SAHARA.$TYPE$_CURRENT OT ' ||
                           'join SAHARA.HOST_CURRENT ON HOST_CURRENT.HOST_KEY = OT.HOST_KEY ' ||
                          'where OT.$PATH_COLUMN$ = $PATH_VALUE$ ' ||
                            'and HOST_CURRENT.DISPLAY_NAME = HOST_NAME_R ' ||
                            ') '|| 
	          'WHERE HOST_NAME = HOST_NAME_R '||
		  ' AND $TYPE$_NAME = $TYPE$_NAME_R ; ' ||
            'end for; ' ||
        'end;';
    SET @vSQL = replace(@vSQL_TEMPLATE, '$TYPE$', @pType);
   
    IF @pType = 'FILESYSTEM' THEN 
      SET @vSQL = REPLACE(@vSQL, '$PATH_COLUMN$', 'DISPLAY_NAME');
      SET @vSQL = REPLACE(@vSQL, '$PATH_VALUE$', 'FILESYSTEM_NAME_R');
    END IF;
    
    IF @pType = 'VOLUME' THEN 
      SET @vSQL = REPLACE(@vSQL, '$PATH_COLUMN$', 'VOLUME_NAME');
      SET @vSQL = REPLACE(@vSQL, '$PATH_VALUE$', 'VOLUME_NAME_R');
    END IF;

 EXECUTE IMMEDIATE @vSQL;
  END;
END;


CALL SAHARA_APP.SP_DROP_('PROCEDURE','SP_IE_CorrelateObjects');
CREATE PROCEDURE SAHARA_APP.SP_IE_CorrelateObjects
(
IN @viewname LONG VARCHAR,
IN @session_key numeric(10)
)
BEGIN
    DECLARE @vRootKey NUMERIC(10);
    DECLARE @vStagingTable VARCHAR(61);
    DECLARE @vType VARCHAR(30);
    DECLARE @vSQL LONG VARCHAR;
   DECLARE @FUNC varchar(64);
    
    BEGIN
    -- get the node key for the root of the view
     SET @vRootKey = 0 ; 

    set @FUNC = 'SP_IE_CorrelateObjects';
    
    call SAHARA.SP_Log_LogDebug(@session_key, @FUNC, 'entry');


     select BVIEW_KEY
      into @vRootKey
      from SAHARA.BVIEW
     where NAME = @viewname;

    if @vRootKey =0  then
      
      CALL SAHARA.SP_Error_RaiseApplicationErrorDetail
        (
            @EBViewNotFound,
            'SP_IE_CorrelateObjects',
            'the business view not found ' || @viewname
        );

    end if;

    -- Iterate over the supported types.  For each, join the node and object
    -- staging tables and set the BVIEW_NODE_KEY column in the object staging
    -- table.  Use this join to call AssociateDimensionRows.  Select all the
    -- objects that don't have BVIEW_NODE_KEY values and mark them
    -- as rejected.




    FOR IETypesLOOP AS IETypesCUR CURSOR FOR 
    select TYPE_NAME from SAHARA_APP.IE_TYPES_
    
    DO
      SET @vType = UPPER(TYPE_NAME);
      SET @vStagingTable = 'SAHARA_APP.IE_' || @vType || '_';

        -- Set the business view node keys for the objects based on
        -- the IE node IDs previously populated by CorrelateNodesAtLevel.

        SET @vSQL =
            'update ' || @vStagingTable || ' STAGE ' ||
               'set BVIEW_NODE_KEY = ' ||
                    '(select BVIEW_NODE_KEY ' ||
                       'from SAHARA_APP.IE_NODE_ ' ||
                      'where STAGE.NODE_ID = IE_NODE_.NODE_ID)';
        execute immediate @vSQL;

        -- Now do the object correlation by filling in the <type>_KEY column
        -- of the object staging table.  If multiple object records match
        -- a criteria, associate the node with first object one we find.

        -- First we'll try based on the object's OID.
        SET @vSQL =
            'update ' || @vStagingTable || ' STAGE ' ||
               'set ' || @vType || '_KEY = ' ||
                    '(select ' || @vType || '_KEY ' ||
                       'from SAHARA.' || @vType || '_CURRENT OBJECT_TYPE ' ||
                      'where OBJECT_TYPE.' || @vType || '_OID = STAGE.OBJECT_UNIQUE_KEY) ' ||
             'where ' || @vType || '_KEY is null ' ||
               'and BVIEW_NODE_KEY is not null';
        execute immediate @vSQL;

        -- try matching the IP address for object types that have them
  
	if @vType in ('HOST', 'ARRAY', 'SWITCH') then
            CALL SAHARA_APP.SP_IE_CorrelateObjectsByIPAddress(@vType);
        end if;

        -- try matching the filer name and fully qualified path
        -- for netapp objects

        if @vType in ('NETAPP_VOLUME', 'NETAPP_SHARE', 'NETAPP_QTREE') then
            CALL SP_IE_CorrelateObjectByNetAppPath(@vType);
        end if;

		-- try matching the host name and object display name
        -- for filesystem and volume objects
        if @vType in ('FILESYSTEM', 'VOLUME') then
            CALL SP_IE_CorrelateObjectByObjectName(@vType);
        end if;

        -- match against the object name

        if @vType in ('APP_GROUP', 'HOST', 'ARRAY', 'SWITCH') then
            SET @vSQL =
                'update ' || @vStagingTable || ' STAGE ' ||
                    'set ' || @vType || '_KEY = ' ||
                        '(select FIRST ' || @vType || '_KEY ' ||
                            'from SAHARA.' || @vType || '_CURRENT OT ' ||
                           'where OT.DISPLAY_NAME = STAGE."NAME" ' ||
                             ') ' ||
                    'where ' || @vType || '_KEY is null ' ||
                      'and BVIEW_NODE_KEY is not null';
            execute immediate @vSQL;
        end if;

        -- Object corellation is complete and recorded in the staging tables.
        -- Create the node to object associations.

        CALL SP_IE_CreateNodeObjectAssociations(@vType);

        -- Anything that correlated is NOT rejected.  Everything else is
        -- already marked rejected.

        SET @vSQL = 'update ' || @vStagingTable || ' ' ||
                   'set REJECTED = ''F'' ' ||
                 'where ' || @vType || '_KEY is not null ' ||
                   'and BVIEW_NODE_KEY is not null';
        execute immediate @vSQL;

	-- Anything that is NOT correlated is rejected.  Everything else is
        -- already marked NOT rejected.

        SET @vSQL = 'update ' || @vStagingTable || ' ' ||
                   'set REJECTED = ''T'' ' ||
                 'where ' || @vType || '_KEY is null ' ||
                   'and BVIEW_NODE_KEY is not null';
   
	execute immediate @vSQL;

        CALL SAHARA.SP_BVIEW_AddDimensionSupport(@vRootKey, @vType);

        
    end for;

    call SAHARA.SP_BVIEW_PublishBV();
  END ;

END;

/* Uncongifure BV */

IF EXISTS (SELECT 1 FROM sys.sysprocedure
        WHERE proc_name = 'SP_BVIEW_DG_UNCONFIG' and user_name(creator) = 'SAHARA')
THEN
        DROP PROCEDURE SAHARA.SP_BVIEW_DG_UNCONFIG;
END IF;

CREATE PROCEDURE SAHARA.SP_BVIEW_DG_UNCONFIG()
BEGIN
call sahara.SP_saharaAPIInit();
delete from sahara.bview_rules where dimension = 'DISKGROUP';
delete from SAHARA_APP.IE_TYPES_ where type_name = 'DISKGROUP';
delete from SAHARA.BVIEW_DIMENSION where dimension = 'DISKGROUP';
delete from SAHARA.COGNOS_FACT_MAPPING where object_type = 'DISKGROUP';
delete from SAHARA.COGNOS_PRESENTATION_SHORTCUT where object_type = 'DISKGROUP';
delete from SAHARA.COGNOS_RELATIONSHIP where LHS_object_type = 'DISKGROUP';
END;

call SAHARA.SP_BVIEW_DG_UNCONFIG();

/* Sahara PD Dump*/

if exists( select 1 from sysprocedure where creator=user_id('SAHARA') and proc_name='SP_DataDict_DelColumnMetadata')
then

/* HOST_CAPACITY*/
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_CAPACITY', 'DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_USED_CAPACITY', 'DB VM Used Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_FREE_CAPACITY', 'DB VM Free Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_OVERHEAD_CAPACITY', 'DB VM Overhead Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'APPS_ON_DB_VM_CAPACITY', 'Apps on DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'APPS_ON_DB_VM_OTHER_CAPACITY', 'Apps on DB VM Other Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_DB_USED_CAPACITY', 'DB VM DB Used Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_DB_USED_OTHER_CAPACITY', 'DB VM DB Used Other Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'DB_VM_UNKNOWN_CAPACITY', 'DB VM Unknown Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'ADJUSTED_DB_VM_CAPACITY', 'Adjusted DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'ADJUSTED_DB_VM_USED_CAPACITY', 'Adjusted DB VM Used Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'ADJUSTED_DB_VM_FREE_CAPACITY', 'Adjusted DB VM Free Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'ADJUSTED_DB_VM_OVERHEAD_CAP', 'Adjusted DB VM Overhead Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'ADJUSTED_APPS_ON_DB_VM_CAP', 'Adjusted Apps on DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'HOST_CAPACITY', 'ADJUSTED_DB_VM_DB_USED_CAP', 'Adjusted DB VM DB Used Capacity');

/* HOST_CAPACITY_ */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_CAPACITY', 'DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_USED_CAPACITY', 'DB VM Used Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_FREE_CAPACITY', 'DB VM Free Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_OVERHEAD_CAPACITY', 'DB VM Overhead Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'APPS_ON_DB_VM_CAPACITY', 'Apps on DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'APPS_ON_DB_VM_OTHER_CAPACITY', 'Apps on DB VM Other Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_DB_USED_CAPACITY', 'DB VM DB Used Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_DB_USED_OTHER_CAPACITY', 'DB VM DB Used Other Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'DB_VM_UNKNOWN_CAPACITY', 'DB VM Unknown Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'ADJUSTED_DB_VM_CAPACITY', 'Adjusted DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'ADJUSTED_DB_VM_USED_CAPACITY', 'Adjusted DB VM Used Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'ADJUSTED_DB_VM_FREE_CAPACITY', 'Adjusted DB VM Free Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'ADJUSTED_DB_VM_OVERHEAD_CAP', 'Adjusted DB VM Overhead Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'ADJUSTED_APPS_ON_DB_VM_CAP', 'Adjusted Apps on DB VM Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'HOST_CAPACITY_', 'ADJUSTED_DB_VM_DB_USED_CAP', 'Adjusted DB VM: DB Used Capacity');

/* DATABASE_CAPACITY */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DATABASE_CAPACITY', 'CAPACITY_FROM_DB_VM', 'Capacity From DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DATABASE_CAPACITY', 'AVAILABLE_FROM_DB_VM', 'Available From DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DATABASE_CAPACITY', 'USED_FROM_DB_VM', 'Used From DB VM');

/* DATABASE_CAPACITY_ */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DATABASE_CAPACITY_', 'CAPACITY_FROM_DB_VM', 'Capacity From DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DATABASE_CAPACITY_', 'AVAILABLE_FROM_DB_VM', 'Available From DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DATABASE_CAPACITY_', 'USED_FROM_DB_VM', 'Used From DB VM');

/* DATABASES */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DATABASES', 'IS_BASED_ON_DB_VM', 'Is Based on DB VM');
/* DATABASES_ */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DATABASES_', 'IS_BASED_ON_DB_VM', 'Is Based on DB VM');

/* VOLUME */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'VOLUME', 'IS_USED_BY_DB_VM', 'Is Used By DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'VOLUME', 'DB_VM_NAME', 'DB VM Name');

/* VOLUME_ */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'VOLUME_', 'IS_USED_BY_DB_VM', 'Is Used by DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'VOLUME_', 'DB_VM_NAME', 'DB VM Name');

/* DISKGROUP */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP', 'REDUNDANCY_TYPE', 'Redundancy Type');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP', 'IS_USED_BY_CLUSTERED_DB', 'Is Used By Clustered DB');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP', 'USES_VM_VOLUMES', 'Uses VM Volumes');
/* DISKGROUP_ */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_', 'REDUNDANCY_TYPE', 'Redundancy Type');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_', 'IS_USED_BY_CLUSTERED_DB', 'Is Used by clustered DB');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_', 'USES_VM_VOLUMES', 'Uses VM Volumes');

/* DISKGROUP_CAPACITY */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CAPACITY', 'OVERHEAD_CAPACITY', 'Overhead capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CAPACITY', 'UNKNOWN_CAPACITY', 'Unknown Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CAPACITY', 'DB_USED_CAPACITY', 'DB Used capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CAPACITY', 'USED_CAPACITY_BY_CLUSTERED_DB', 'Used Capacity By Clustered DB');
/* DISKGROUP_CAPACITY_ */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_CAPACITY_', 'OVERHEAD_CAPACITY', 'Overhead capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_CAPACITY_', 'UNKNOWN_CAPACITY', 'Unknown Capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_CAPACITY_', 'DB_USED_CAPACITY', 'DB Used capacity');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA_APP', 'DISKGROUP_CAPACITY_', 'USED_CAPACITY_BY_CLUSTERED_DB', 'Used Capacity By Clustered DB');

/* DATABASES_CURRENT */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DATABASES_CURRENT', 'IS_BASED_ON_DB_VM', 'Is Based on DB VM');

/* VOLUME_CURRENT */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'VOLUME_CURRENT', 'IS_USED_BY_DB_VM', 'Is Used By DB VM');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'VOLUME_CURRENT', 'DB_VM_NAME', 'DB VM Name');

/* DISKGROUP_CURRENT */
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CURRENT', 'REDUNDANCY_TYPE', 'Redundancy Type');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CURRENT', 'IS_USED_BY_CLUSTERED_DB', 'Is Used By Clustered DB');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_CURRENT', 'USES_VM_VOLUMES', 'Uses VM Volumes');

/* DATBASES RAC changes*/
call SAHARA.SP_DataDict_ColumnMetadata('SAHARA', 'DATABASES', 'IS_RAC_AWARE', 'IS RAC AWARE');
call SAHARA.SP_DataDict_ColumnMetadata('SAHARA', 'DATABASES_CURRENT', 'IS_RAC_AWARE', 'IS RAC AWARE');

/* DISKGROUP_BVIEW_NODE */
call SAHARA.SP_DataDict_DelTableMetadata('SAHARA', 'DISKGROUP_BVIEW_NODE', 'Diskgroup Bview node');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_BVIEW_NODE', 'BVIEW_NODE_KEY', 'Business View Node Key');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_BVIEW_NODE', 'DISKGROUP_KEY', 'diskgroup_key');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_BVIEW_NODE', 'BVIEW_KEY', 'Business View Key');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'DISKGROUP_BVIEW_NODE', 'STATUS', 'Status');


/* INSTALLED_ADDONS*/
call SAHARA.SP_DataDict_DelTableMetadata('SAHARA', 'INSTALLED_ADDONS', 'Installed Addons');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'INSTALLED_ADDONS', 'ID', 'ID');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'INSTALLED_ADDONS', 'DISPLAY_NAME', 'Display Name');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'INSTALLED_ADDONS', 'VERSION', 'Version');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'INSTALLED_ADDONS', 'DESCRIPTION', 'Description');
call SAHARA.SP_DataDict_DelColumnMetadata('SAHARA', 'INSTALLED_ADDONS', 'INSTALL_DATE', 'Install date');

end if;

commit;

/* Revert FCAST change to pre-existing column */
update sahara.COLUMN_METADATA_BASE set is_forecast_enable = 'F' where table_name = 'DATABASES' and column_name = 'IS_RAC_AWARE';


/* drop procs*/ 

if exists(select 1 from sys.sysprocedure where proc_name = 'SP_DataDict_DelTableMetadata' and user_name(creator) = 'SAHARA') then
   drop procedure sahara.SP_DataDict_DelTableMetadata
end if;

if exists(select 1 from sys.sysprocedure where proc_name = 'SP_DataDict_DelColumnMetadata' and user_name(creator) = 'SAHARA') then
   drop procedure sahara.SP_DataDict_DelColumnMetadata
end if;

/* remove addon entry*/
-- delete from SAHARA.INSTALLED_ADDONS where ID='HF_VOMA_0400045800-02';

/* Sahara views */

/* View: DATABASE_CURRENT*/
if exists(select 1 from sys.systable where table_name='DATABASES_CURRENT' and table_type='VIEW' and creator=user_id('SAHARA')) then
   drop view SAHARA.DATABASES_CURRENT
end if;

create view SAHARA.DATABASES_CURRENT  as
select DATABASES_KEY,
       HOST_KEY,
       DATABASES_OID,
       CC_STORAGE_URL,
       DISPLAY_NAME,
       INSTANCE_DISPLAY_NAME,
       DATABASE_TYPE,
       DATABASE_VERSION,
       DATABASE_STATE,
       DISCOVERY_STATE,
       IS_CLUSTERED,
       IS_RAC_AWARE,
       IS_BASED_ON_THIN,
       APPLICATION_BE,
       APPLICATION_COMPOSITE_BE,
       ORGANIZATION_BE,
       ORGANIZATION_COMPOSITE_BE
  from SAHARA.DATABASES
 where T2_IS_CURRENT = 'T'
   and T2_IS_DELETED = 'F';

comment on view SAHARA.DATABASES_CURRENT is 
'This view filters the DATABASES table to just those rows which represent "current" active objects.  Obsolete "duplicate" rows from "type 2" updates and rows marked deleted are excluded.  The *_CURRENT views provide the simplist access to a current inventory of objects.';

grant SELECT on SAHARA.DATABASES_CURRENT to SAHARA_APP;

/* View: DISKGROUP_CURRENT */
if exists(select 1 from sys.systable where table_name='DISKGROUP_CURRENT' and table_type='VIEW' and creator=user_id('SAHARA')) then
   drop view SAHARA.DISKGROUP_CURRENT
end if;

create view SAHARA.DISKGROUP_CURRENT (DISKGROUP_KEY, DISKGROUP_OID, HOST_KEY, CC_STORAGE_URL, DISPLAY_NAME, FAMILY, VERSION, TYPE, IS_SHARED, IS_BASED_ON_DIRECT_ATTACHED, IS_BASED_ON_THIN, STATE, APPLICATION_BE, APPLICATION_COMPOSITE_BE, ORGANIZATION_BE, ORGANIZATION_COMPOSITE_BE) as
select DISKGROUP_KEY,
       DISKGROUP_OID,       
       HOST_KEY,
       CC_STORAGE_URL,
       DISPLAY_NAME,       
       FAMILY,
       VERSION,
       TYPE,
       IS_SHARED,
       IS_BASED_ON_DIRECT_ATTACHED,
       IS_BASED_ON_THIN,
       STATE,
       APPLICATION_BE,
       APPLICATION_COMPOSITE_BE,
       ORGANIZATION_BE,
       ORGANIZATION_COMPOSITE_BE
  from SAHARA.DISKGROUP 
 where T2_IS_CURRENT = 'T'
   and T2_IS_DELETED = 'F';

comment on view SAHARA.DISKGROUP_CURRENT is 
'This view filters the DISKGROUP table to just those rows which represent "current" active objects.  Obsolete "duplicate" rows from "type 2" updates and rows marked deleted are excluded.  The *_CURRENT views provide the simplist access to a current inventory of objects.';

grant SELECT on SAHARA.DISKGROUP_CURRENT to SAHARA_APP;

/* View: VOLUME_CURRENT */
if exists(select 1 from sys.systable where table_name='VOLUME_CURRENT' and table_type='VIEW' and creator=user_id('SAHARA')) then
   drop view SAHARA.VOLUME_CURRENT
end if;

create view SAHARA.VOLUME_CURRENT  as
select VOLUME_KEY,
       VOLUME_OID,
       CC_STORAGE_URL,
       DISKGROUP_KEY,
       HOST_KEY,
       VOLUME_NAME,
       VOLUME_NAME AS DISPLAY_NAME,
       VM_VERSION,
       VM_TYPE,
       DISK_GROUP_NAME,
       VOLUME_LAYOUT,
       IS_VCS_CVM,
       IS_USED_BY_FILESYSTEM,
       IS_USED_BY_APPLICATION,
       IS_DIRECT_ATTACHED,
       IS_COMPONENT,
       IS_BASED_ON_THIN,
       IS_EXPORTED,
       VOLUME_TYPE,
       APPLICATION_BE,
       APPLICATION_COMPOSITE_BE,
       ORGANIZATION_BE,
       ORGANIZATION_COMPOSITE_BE
  from SAHARA.VOLUME
 where T2_IS_CURRENT = 'T'
   and T2_IS_DELETED = 'F';

comment on view SAHARA.VOLUME_CURRENT is 
'This view filters the VOLUME table to just those rows which represent "current" active objects.  Obsolete "duplicate" rows from "type 2" updates and rows marked deleted are excluded.  The *_CURRENT views provide the simplist access to a current inventory of objects.';

grant SELECT on SAHARA.VOLUME_CURRENT to SAHARA_APP;

commit;

begin
                message '-- configuring data set DISKGROUP_DIM...' to log;
    call sahara.SP_DataDict_RollupDataSetType
    (
        'DG_DIM',                       -- name
        'DIMENSION',                        -- stereotype
        'DISKGROUP',                           -- destination table
        'DISKGROUP_',                          -- staging table
                                null,


        'select $SRC_COLUMNS$, HOST_CURRENT.HOST_KEY ' ||
          'from SAHARA_APP."$SRC_TABLE$" SRC ' ||
          'join SAHARA.HOST_CURRENT ' ||
            'on SRC.HOST_OID = HOST_CURRENT.HOST_OID',
                                'diskgroup_dim.csv',
                                'vrts_vxvm_diskgroup'
    );
    call sahara.SP_DataDict_RollupDataSetColumn ('DG_DIM', 'DISKGROUP_OID', 'STAGING KEY');
    call sahara.SP_DataDict_RollupDataSetColumn ('DG_DIM', 'DISKGROUP_KEY', 'NONE');
    call sahara.SP_DataDict_RollupDataSetColumn ('DG_DIM', 'CC_STORAGE_URL', 'TYPE 1',
                            '@URL1 || SRC.DISKGROUP_OID || @URL2');
end;

commit;

begin
                message '-- configuring data set VOLUME_DIM...' to log;
    call sahara.SP_DataDict_RollupDataSetType
    (
        'VOLUME_DIM',                       -- name
        'DIMENSION',                        -- stereotype
        'VOLUME',                           -- destination table
        'VOLUME_',                          -- staging table
                                null,


--        'select $SRC_COLUMNS$, HOST_CURRENT.HOST_KEY ' ||
--          'from SAHARA_APP."$SRC_TABLE$" SRC ' ||
--          'join SAHARA.HOST_CURRENT ' ||
--            'on SRC.HOST_OID = HOST_CURRENT.HOST_OID'

        'select $SRC_COLUMNS$, HOST_CURRENT.HOST_KEY, DISKGROUP_CURRENT.DISKGROUP_KEY ' ||
          'from SAHARA_APP."$SRC_TABLE$" SRC ' ||
          'join SAHARA.HOST_CURRENT ' ||
            'on SRC.HOST_OID = HOST_CURRENT.HOST_OID ' ||
          'left outer join SAHARA.DISKGROUP_CURRENT ' ||
            'on SRC.DISKGROUP_OID = DISKGROUP_CURRENT.DISKGROUP_OID',
                                'volume_dim.csv',
                                'vrts_vxvm_volume'
    );
    call sahara.SP_DataDict_RollupDataSetColumn ('VOLUME_DIM', 'VOLUME_OID', 'STAGING KEY');
    call sahara.SP_DataDict_RollupDataSetColumn ('VOLUME_DIM', 'VOLUME_KEY', 'NONE');
    call sahara.SP_DataDict_RollupDataSetColumn ('VOLUME_DIM', 'CC_STORAGE_URL', 'TYPE 1',
                            '@URL1 || SRC.VOLUME_OID || @URL2');
end;

commit;

begin
                message '-- configuring data set DB_DIM...' to log;
    call sahara.SP_DataDict_RollupDataSetType
    (
        'DB_DIM',                           -- name
        'DIMENSION',                        -- stereotype
        'DATABASES',                        -- destination table
        'DATABASES_',                       -- staging table
                                null,

        'select $SRC_COLUMNS$, HOST_CURRENT.HOST_KEY ' ||
          'from SAHARA_APP."$SRC_TABLE$" SRC ' ||
          'join SAHARA.HOST_CURRENT ' ||
            'on SRC.HOST_OID = HOST_CURRENT.HOST_OID',
                                'database_dim.csv',
                                'vrts_dbed_basic'
    );
    call sahara.SP_DataDict_RollupDataSetColumn('DB_DIM', 'DATABASES_OID', 'STAGING KEY');
    call sahara.SP_DataDict_RollupDataSetColumn('DB_DIM', 'DATABASES_KEY', 'NONE');
    call sahara.SP_DataDict_RollupDataSetColumn('DB_DIM', 'CC_STORAGE_URL', 'TYPE 1',
                            '@URL1 || SRC.DATABASES_OID || @URL2');
end;

commit;

call sahara.SP_DataDict_BindRDSTypeToRSType('Veritas Operations Manager 5.0', 'DG_DIM');
call sahara.SP_DataDict_BindRDSTypeToRSType('Veritas Operations Manager 5.0', 'VOLUME_DIM');
call sahara.SP_DataDict_BindRDSTypeToRSType('Veritas Operations Manager 5.0', 'DB_DIM');

commit;

BEGIN
  DECLARE @vSQL LONG VARCHAR;
  DECLARE @vStagingTableName VARCHAR(1024);
  DECLARE @vStagingColExists INTEGER;  
  
  

FOR AttributesLOOP as AttributesCUR dynamic scroll cursor for
      select CUSTOM_ATTRIBUTE_KEY as CUSTOM_ATTRIBUTE_KEY_R,
        CUSTOM_ATTRIBUTE_CONTEXT as CUSTOM_ATTRIBUTE_CONTEXT_R,
        TYPE as TYPE_R,
        DISPLAY_NAME as DISPLAY_NAME_R,
        COLUMN_NAME as COLUMN_NAME_R,
        COLUMN_TYPE as COLUMN_TYPE_R,
        SOURCE_NAME as SOURCE_NAME_R    
      from SAHARA.CUSTOM_ATTRIBUTE CONFIGURED
      where CONFIGURED.SOURCE_NAME not in ('ORGANIZATION_BE','APPLICATION_BE', 'ORGANIZATION_COMPOSITE_BE','APPLICATION_COMPOSITE_BE','BUSINESSENTITY')
	    and exists (select 1
                         from SAHARA.P_CUSTOM_ATTRIBUTE PUBLISHED
                        where PUBLISHED.CUSTOM_ATTRIBUTE_KEY =
                              CONFIGURED.CUSTOM_ATTRIBUTE_KEY)
     DO            

            

                if SAHARA.fn_HELPER_ColumnExists('SAHARA_APP',CUSTOM_ATTRIBUTE_CONTEXT_R || '_',
                    COLUMN_NAME_R) = 0 THEN
                    SET @vSQL = 'lock table ' ||
                    -- source table or view
                    'SAHARA_APP.' || CUSTOM_ATTRIBUTE_CONTEXT_R || '_ ' ||
                            'in exclusive mode';

                    EXECUTE IMMEDIATE @vSQL;

                    SET @vSQL = 'alter table SAHARA_APP.' || CUSTOM_ATTRIBUTE_CONTEXT_R
                        || '_ add ("' || COLUMN_NAME_R || '" ' || COLUMN_TYPE_R || ')';
                    EXECUTE IMMEDIATE @vSQL;                    
                end if;    	        
            -- release the table locks
      COMMIT ;
     END FOR;     
END;

/*Removing view for DG BV*/
BEGIN
create variable @fullName varchar(1024);
create variable @query varchar(1024);

for @l as @c cursor for select user_name(creator) as @user,
                               table_name as @name
                          from sys.systable where table_name like 'BV_DISKGROUP%' and 
table_type='VIEW' 
and creator=user_id('SAHARA')
     DO         
        set @fullName = '"' || @user || '"."' || @name || '"';   
        set @query = 'drop view ' || @fullName;    
        execute immediate with quotes @query;           
     END FOR;
drop variable @fullName;
drop variable @query;
END;

call sahara.SP_recompile_views();
commit;

if exists(select 1 from sys.sysprocedure where proc_name = 'SP_DAILY_SUMMARIZATION' and user_name(creator) = 'SAHARA') then
   drop procedure sahara.SP_DAILY_SUMMARIZATION
end if;

CREATE PROCEDURE SAHARA.SP_DAILY_SUMMARIZATION(@pADATE date)

BEGIN

   DECLARE @FUNC                       varchar(256);

   DECLARE @pRollupBatch               numeric(10);
   DECLARE @pDates_key                 numeric(10);
   DECLARE @pYear_Period_key           numeric(10);
   DECLARE @pRollup_source_key         numeric(10);

   DECLARE @pADATE_Yesterday           date;
   DECLARE @pADATE_PrevSuccRollup      date;

   DECLARE @error                      integer;
   DECLARE @sqlstate                   varchar(5);
   DECLARE @serror                     varchar(512);
   DECLARE @section                    varchar(512);

   DECLARE @pQuarterNumber             int;
   DECLARE @pMonthNumber               int;
   DECLARE @pYearNumber                int;
   DECLARE @pWeekNumber                int;
   DECLARE @last_summarization_time    date;

   set @FUNC = 'SP_DAILY_SUMMARIZATION';

   call SAHARA.SP_saharaAPIInit();
   call SP_Log_LogDebug(null, @FUNC, 'enter');

   set @last_summarization_time =
       sahara.fn_conf_GetConfigDate('TREND_DATA_RETENTION', 'LAST_SUMMARIZATION_TIME');

   set @pADATE_Yesterday = @pADATE;

   if @pADATE_Yesterday = @last_summarization_time
   then
       return; -- summarization has been executed
   end if;

   for rollup_source_entry as rollup_source_loop cursor for
          select rs.rollup_source_key rsk
          from sahara.rollup_source rs
            inner join sahara.rollup_batch rb on rs.rollup_source_key = rb.rollup_source_key
            inner join sahara.dates dates     on rb.dates_key = dates.dates_key
          where dates.adate = @pADATE_Yesterday and
                rb.rollup_batch_key in (select max(rollup_batch_key) from sahara.rollup_batch where is_success = 'T' group by dates_key)
          order by rsk asc
   do

       select max(dates.adate) into @pADATE_PrevSuccRollup
       from sahara.rollup_batch rb
            inner join sahara.dates dates on rb.dates_key = dates.dates_key
       where dates.adate < @pADATE_Yesterday and
             rb.rollup_source_key = rsk      and
             rb.rollup_batch_key in
               (select max(rollup_batch_key) from sahara.rollup_batch where is_success = 'T' and rollup_source_key = rsk group by dates_key);

       if @pADATE_PrevSuccRollup is null
       then
           set @pADATE_PrevSuccRollup = @pADATE_Yesterday;
       end if;

       -- This is to adjust the case that rollup is fine, but unable to process DAILY_SUMMARIZATION.
       if @pADATE_PrevSuccRollup > @last_summarization_time
       then
           set @pADATE_PrevSuccRollup = @last_summarization_time;
       end if;

       set @pYearNumber = 0;

       for adate_entry as adate_loop cursor for
           select adate as adate
           from sahara.dates da
           where adate >= @pADATE_PrevSuccRollup and adate <= @pADATE_Yesterday
           order by adate asc
       do

       begin

           savepoint SP_DAILY_SUMMARIZATION;

           set @section = string('rollup_source_key=',rsk, 'adate=',adate, ',period=','week');
           call sahara.SP_SUMMARIZE_PERIOD(rsk, adate, 'week');

           set @section = string('rollup_source_key=',rsk, 'adate=',adate, ',period=','quarter');
           call sahara.SP_SUMMARIZE_PERIOD(rsk, adate, 'month');

           set @section = string('rollup_source_key=',rsk, 'adate=',adate, ',period=','month');
           call sahara.SP_SUMMARIZE_PERIOD(rsk, adate, 'quarter');

           set @section = string('rollup_source_key=',rsk, 'adate=',adate, ',period=','year');
           call sahara.SP_SUMMARIZE_PERIOD(rsk, adate, 'year');

           commit;
       EXCEPTION
             WHEN OTHERS THEN
            SELECT SQLCODE, SQLSTATE, ERRORMSG() INTO @error, @sqlstate, @serror;
            IF ( @error <> 0 )
            THEN
                BEGIN
                    call SP_Log_LogError(null, @FUNC,
                                               string ('          @error    = ', @error ) +
                                               string ('         @serror    = ', @serror ) +
                                               string ('       @sqlstate    = ', @sqlstate ) +
                                               string (' Error failed at    = ', @FUNC+':'+@section ) );
                    rollback to savepoint SP_DAILY_SUMMARIZATION;
                END;
            END IF;

       end;

       end for;

   end for;

   call SAHARA.fn_Configuration_InstallDate (
        'TREND_DATA_RETENTION',                     -- section
        'LAST_SUMMARIZATION_TIME',                  -- name
        date(dateadd( day, -1, now(*))),            -- value
        'Last Time the Data Summarization is processed.',       -- display name
        -- description
        '',
        0,
        1
    );

   call SP_Log_LogDebug(null, @FUNC, 'exit');


END;

IF EXISTS (select * from sys.sysprocedure sp key join sysusers u
 where sp.proc_name = 'SP_fix_duplicate_summary_data' and u.name = 'SAHARA' ) THEN
  DROP PROCEDURE SAHARA.SP_fix_duplicate_summary_data;
END IF;

commit;