# support modules expected in the current directory

use strict;
use warnings;
use VRTS::CMD;
use strict;
use Cwd;
use File::Path;
use Getopt::Long;
#use ERUsers;
#use SybaseHelpers;
#use CognosMetamodel;
use File::Copy;
use File::Spec;
use     CGI;

BEGIN 
{
	my $installpath = "/opt/VRTSvomer/inst/perl";
	my $vomerperl;
	my $vomerpath;
	my $vomerbinpath;
	my $vomerlibasa;
	if ($^O =~ /Win32/i)
	{
		my $rq = &VRTS::CMD::REGQUERY; 

		my $cmd = "$rq query"." \"SOFTWARE\\Symantec\\VOMER\""." \"installdir\" ";
		my $dir = `$cmd`;
		chomp($dir);

		$installpath = $dir;
		$installpath = $installpath."\\inst\\perl";
		$vomerperl = $dir."\\lib\\perlmodules";
		$vomerpath = $dir."\\inst\\perl";
		$vomerbinpath = $dir."\\bin";
		$vomerlibasa = $dir."\\lib\\asa";
	}
	
	unshift @INC, $installpath;    
	unshift @INC, $vomerperl;    
	unshift @INC, $vomerpath;
	unshift @INC, $vomerbinpath;    
	unshift @INC, $vomerlibasa;	
}

use Getopt::Long;
#use VRTS::Paths;
use File::Path;
use File::Spec;
use File::Copy;
use VRTS::ERConfig; 
require VRTS::VOMERPaths;
require VRTS::Util;


my $servername="";
my $installdir="";
my $apppath="";
my $kettlehome = "";
my $arraydimension = "";
my $arraydimensionbkp = "";
my $arrayfactetl = "";
my $arrayfactetlbkp = "";
my $etlhome = "";
my $dstsaharaallxmlbkp = "";
my $dbpath = "";
my $HOTFIXDIR = "";
my $_installdir = VRTS::Paths::get_path ("InstallDir");
my $installdirmh  = File::Spec->canonpath ($_installdir);
my $perlbin = File::Spec->catfile   ($installdirmh, "bin");
my $vomadm = File::Spec->catfile   ($installdirmh, "bin", "vomadm");
my $conf_root_dir = "";
my @tar_files = ();
$SIG{"PIPE"} = sub { die; };
	my $erSybasePath = File::Spec->catfile (VRTS::ERConfig::get_installdirer() , "lib", "ASA");
    $ENV{'SystemRoot'} =~ /([A-Za-z]:\\[A-Za-z0-9_ ]+)/;
    my $system32_dir = $1."\\system32".";".$1."\\system32\\wbem";
	$ENV{'PATH'} = $system32_dir.";".$erSybasePath;	

delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};

$ENV {'KETTLE_HOME'} = File::Spec->catfile (VRTS::ERConfig::get_installdirer() , "etl");
print "Kettle home \n";
print $ENV{KETTLE_HOME};
#Setting Java Home in the environment, because this is required by some of the Cognos configuration scripts.
$ENV{'JAVA_HOME'} = VRTS::ERConfig::get_java_home();
       $apppath        = VRTS::VOMERPaths::get_apppath();
my $eat_data_dir = File::Spec->catdir($apppath,"sec");
my $eat_home_dir = File::Spec->catdir($installdir,"sec");
$ENV{"EAT_DATA_DIR"} = $eat_data_dir;
$ENV{"EAT_HOME_DIR"} = $eat_home_dir;

require wincognosconfig;
my $query = new CGI;
my $cs = $query->param("cs-hostname");
#main

my $logfile = File::Spec->catfile($apppath, "logs", 'VRTSvomeshsclpack1-5.0.405.0_Install.log');
open (FILE, ">$logfile")|| die ("ERROR: Can't open $logfile:$!");
print FILE "SFA Installation Log\n";
print FILE "--------------------\n";
print FILE "SFA Installation Started " . VRTS::ERConfig::get_timestamp() . "\n\n";

initialize_variables();

print FILE "Stopping Services..." . VRTS::ERConfig::get_timestamp() . "\n";
execute_stop_services();

print FILE "\nFile copy in progress..." . VRTS::ERConfig::get_timestamp() . "\n";
copy_files();

print FILE "\nDatabase upgrade in progress..." . VRTS::ERConfig::get_timestamp() . "\n";
alter_database();

print FILE "\nForecasting fix in progress..." . VRTS::ERConfig::get_timestamp() . "\n";
fix_duplicate_summary_data();

print FILE "\nUpdating metamodel..." . VRTS::ERConfig::get_timestamp() . "\n";
updating_the_metamodel();

print FILE "\nImporting Reports..." . VRTS::ERConfig::get_timestamp() . "\n";
import_reports();

delete_work_dir();

print FILE "\nUpdating Online Help..." . VRTS::ERConfig::get_timestamp() . "\n";
update_OLH();

print FILE "\nStarting Services..." . VRTS::ERConfig::get_timestamp() . "\n";
execute_start_services();

print FILE "\nSFA Installation Completed. " . VRTS::ERConfig::get_timestamp() . "\n\n";
close FILE;

exit 0;


# initilaizing the variables
sub initialize_variables {
# getting the install directory
       $installdir        = VRTS::VOMERPaths::get_installpath();
	if ( $installdir eq "") {
	   die "No install directory exiting ..!";
	}
	#print "Printing the install directory $installdir \n";
# Getting the application directory
       $apppath        = VRTS::VOMERPaths::get_apppath();
	if ( $apppath eq "") {
	   die "No apppath directory exiting ..!";
	}
$conf_root_dir = File::Spec->catfile   ($installdir, "conf");

# Get the kettle home directory
	$kettlehome = File::Spec->catdir($installdir,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server");	

	$etlhome = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0");	

}

# initilaizing the variables
sub copy_files {

   print "Copy the kettle files \n";
  $HOTFIXDIR = $ENV{"Store"};

# copying the extractions scripts
   my $srcetlfile = File::Spec->catdir($HOTFIXDIR,"etl","db_source_scripts","vom_4_0","database_data.sql");	
   my $dstetlfile = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","database_data.sql");	
   my $dstetlfilebkp = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","database_data.sql.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catdir($HOTFIXDIR,"etl","db_source_scripts","vom_4_0","dg_data.sql");	
   $dstetlfile = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","dg_data.sql");	
   $dstetlfilebkp = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","dg_data.sql.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catdir($HOTFIXDIR,"etl","db_source_scripts","vom_4_0","volume_data.sql");	
   $dstetlfile = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","volume_data.sql");	
   $dstetlfilebkp = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","volume_data.sql.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catdir($HOTFIXDIR,"etl","db_source_scripts","vom_4_0","host_consumption_data.sql");	
   $dstetlfile = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","host_consumption_data.sql");	
   $dstetlfilebkp = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","host_consumption_data.sql.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catdir($HOTFIXDIR,"etl","db_source_scripts","vom_4_0","host_data.sql");	
   $dstetlfile = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","host_data.sql");	
   $dstetlfilebkp = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","host_data.sql.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catdir($HOTFIXDIR,"etl","db_source_scripts","vom_4_0","license_data.sql");	
   $dstetlfile = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","license_data.sql");	
   $dstetlfilebkp = File::Spec->catdir($installdir,"etl","db_source_scripts","vom_4_0","license_data.sql.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

#copying the kettle jobs
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server","database_data","database_dimension.ktr");	
   $dstetlfile = File::Spec->catfile($kettlehome,"database_data","database_dimension.ktr");	
   $dstetlfilebkp = File::Spec->catfile($kettlehome,"database_data","database_dimension.ktr.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server","database_data","database_facts.ktr");	
   $dstetlfile = File::Spec->catfile($kettlehome,"database_data","database_facts.ktr");	
   $dstetlfilebkp = File::Spec->catfile($kettlehome,"database_data","database_facts.ktr.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server","diskgroup_data","diskgroup_dimension.ktr");	
   $dstetlfile = File::Spec->catfile($kettlehome,"diskgroup_data","diskgroup_dimension.ktr");	
   $dstetlfilebkp = File::Spec->catfile($kettlehome,"diskgroup_data","diskgroup_dimension.ktr.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
		
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server","diskgroup_data","diskgroup_facts.ktr");	
   $dstetlfile = File::Spec->catfile($kettlehome,"diskgroup_data","diskgroup_facts.ktr");	
   $dstetlfilebkp = File::Spec->catfile($kettlehome,"diskgroup_data","diskgroup_facts.ktr.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server","host_data","host_facts.ktr");	
   $dstetlfile = File::Spec->catfile($kettlehome,"host_data","host_facts.ktr");	
   $dstetlfilebkp = File::Spec->catfile($kettlehome,"host_data","host_facts.ktr.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
		
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"etl","rollup_process","rollup_mgmt_servers","rollup_mgmt_server","volume_data","volume_dimension.ktr");	
   $dstetlfile = File::Spec->catfile($kettlehome,"volume_data","volume_dimension.ktr");	
   $dstetlfilebkp = File::Spec->catfile($kettlehome,"volume_data","volume_dimension.ktr.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
   
#copying the GUI files
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"esmweb","webgui","sm","WEB-INF","lib","erweb.jar");	
   $dstetlfile = File::Spec->catfile($installdir,"esmweb","webgui","sm","WEB-INF","lib","erweb.jar");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"esmweb","webgui","sm","WEB-INF","lib","erweb.jar.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"esmweb","webgui","sm","plugins","ER","js","Rollup","DataSourcePanel.js");	
   $dstetlfile = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","js","Rollup","DataSourcePanel.js");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","js","Rollup","DataSourcePanel.js.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
   
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"esmweb","webgui","sm","plugins","ER","settings","CSSettings.jsp");	
   $dstetlfile = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","settings","CSSettings.jsp");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","settings","CSSettings.jsp.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
   
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"esmweb","webgui","sm","plugins","ER","settings","installed_addons.jsp");	
   $dstetlfile = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","settings","installed_addons.jsp");	
   # since below installed_addons.jsp is new file, no need to create a backup for it.
   #$dstetlfilebkp = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","settings","installed_addons.jsp.bkup");
   #copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
   
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"esmweb","webgui","sm","plugins","ER","js","modify_upload_validations.js");	
   $dstetlfile = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","js","modify_upload_validations.js");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"esmweb","webgui","sm","plugins","ER","js","modify_upload_validations.js.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

#copying the BV files
# coping the bv_export_csv.pl file

 $srcetlfile = File::Spec->catfile($HOTFIXDIR,"src","import","bv_export_csv.pl");	
   $dstetlfile = File::Spec->catfile($installdir,"bin","bv_export_csv.pl");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"bin","bv_export_csv.pl.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

# coping the bv_create.pl file

 $srcetlfile = File::Spec->catfile($HOTFIXDIR,"src","import","bv_create.pl");	
   $dstetlfile = File::Spec->catfile($installdir,"bin","bv_create.pl");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"bin","bv_create.pl.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
  
# coping the bv_import_csv.pl file

 $srcetlfile = File::Spec->catfile($HOTFIXDIR,"src","import","bv_import_csv.pl");	
   $dstetlfile = File::Spec->catfile($installdir,"bin","bv_import_csv.pl");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"bin","bv_import_csv.pl.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

# coping the CSVResources.pm file

 $srcetlfile = File::Spec->catfile($HOTFIXDIR,"src","import","CSVResources.pm");	
   $dstetlfile = File::Spec->catfile($installdir,"lib","perl","CSVResources.pm");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"lib","perl","CSVResources.pm.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

# coping the sample.view file

 $srcetlfile = File::Spec->catfile($HOTFIXDIR,"src","tests","import","sample.view");	
   $dstetlfile = File::Spec->catfile($installdir,"business_views","sample.view");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"business_views","sample.view.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

#copying the Cognos files
# coping the .cpf file
   my $srcsaharacpf = File::Spec->catdir($HOTFIXDIR,"inst","cogconfig","sahara.cpf");	
   my $dstsaharacpf = File::Spec->catdir($installdir,"inst","cogconfig","sahara.cpf");	
   my $dstsaharacpfbkp = File::Spec->catdir($installdir,"inst","cogconfig","sahara.cpf.bkp");	

   copy($dstsaharacpf,$dstsaharacpfbkp);
   copy($srcsaharacpf,$dstsaharacpf);

# copying the model xml
   my $srcmodellxml = File::Spec->catdir($HOTFIXDIR,"inst","cogconfig","model.xml");	
   my $dstmodellxml = File::Spec->catdir($installdir,"inst","cogconfig","model.xml");	
   my $dstmodellxmlbkp = File::Spec->catdir($installdir,"inst","cogconfig","model.xml.bkp");	

   copy($dstmodellxml,$dstmodellxmlbkp);
   copy($srcmodellxml,$dstmodellxml);

# copying customdata xml
   my $srccustomdataxml = File::Spec->catdir($HOTFIXDIR,"inst","cogconfig","customdata.xml");	
   my $dstcustomdataxml = File::Spec->catdir($installdir,"inst","cogconfig","customdata.xml");	
   my $dstcustomdataxmlbkp = File::Spec->catdir($installdir,"inst","cogconfig","customdata.xml.bkp");	

   copy($dstcustomdataxml,$dstcustomdataxmlbkp);
   copy($srccustomdataxml,$dstcustomdataxml);

   my $srcreportszip = File::Spec->catdir($HOTFIXDIR,"inst","cogconfig","er-5.0-reports.zip");	
   my $dstreportszip = File::Spec->catdir($installdir,"inst","cogconfig","er-5.0-reports.zip");	
   my $dstreportszipbkp = File::Spec->catdir($installdir,"inst","cogconfig","er-5.0-reports.zip.bkp");	

   copy($dstreportszip,$dstreportszipbkp);
   copy($srcreportszip,$dstreportszip);


   # Forecasting - Adding fix to round date diff between two dates, instead of truncating it
   $srcetlfile = File::Spec->catdir($HOTFIXDIR,"Cognos","Webapps","p2pd","Forecasting_XMLDataSource.jsp");	
   $dstetlfile = File::Spec->catdir($installdir,"Cognos","Webapps","p2pd","Forecasting_XMLDataSource.jsp");	
   $dstetlfilebkp = File::Spec->catdir($installdir,"Cognos","Webapps","p2pd","Forecasting_XMLDataSource.jsp.bkp");	
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);

   # vomesgather fix
   $srcetlfile = File::Spec->catfile($HOTFIXDIR,"tools","vomesgather.pm");	
   $dstetlfile = File::Spec->catfile($installdir,"tools","vomesgather.pm");	
   $dstetlfilebkp = File::Spec->catfile($installdir,"tools","vomesgather.pm.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);
   
   # Replace file in Cmdlet location
   $dstetlfile = File::Spec->catfile($installdirmh,"lib", "modules", "VRTS","VomAdm","Cmdlet","vomesgather.pm");
   $dstetlfilebkp = File::Spec->catfile($installdirmh,"lib", "modules", "VRTS","VomAdm","Cmdlet","vomesgather.pm.bkup");
   copy($dstetlfile,$dstetlfilebkp);
   copy($srcetlfile,$dstetlfile);


}

sub execute_stop_services {

    my $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--stop",
						"Apache");
   

 my 	 $result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  stop command Apache");
	}

   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--stop",
						"Database");
   

 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  stop command Database");
	}

   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--stop",
						"GUI");
   

 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  stop command GUI");
	}

	return $result;

}
sub execute_start_services {

my   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--start",
						"Apache");
   

 my	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  start command Apache");
	}

   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--start",
						"Database");
   

 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  start command Database");
	}

   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--start",
						"GUI");
   

 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  start command GUI");
	}

	return $result;
}

#Get the hostname
sub get_host_short_name
{
  my $computer_name_cmd = VRTS::Util::make_command(File::Spec->catfile($installdirmh,"bin","regquery.exe"),
                                         "query",
		"\"SYSTEM\\ControlSet001\\Control\\ComputerName\\ComputerName\"",
                                     "\"ComputerName\"",
                                         "|");
   open (H,$computer_name_cmd);
   my $hostname = <H>;
   chomp($hostname);

   my $shortname;
   my $dontcare;

   chomp($hostname);
   ($shortname, $dontcare) = split(/\./, $hostname);
   return $shortname;
}

sub 
alter_database{
# Calling the DB upgrade script
 execute_sql("$HOTFIXDIR\\asadb\\scripts\\upgrade_db_501.sql");
}

sub 
fix_duplicate_summary_data{
# Execute forecasting fix 
 execute_sql("$HOTFIXDIR\\asadb\\scripts\\upgrade_call_501.sql");
}

# Executing the sql file
sub
execute_sql {
	my $SQLFILE = shift;
                      my $rq = &VRTS::CMD::REGQUERY;
   my $cmd = "$rq query"." \"SOFTWARE\\Symantec\\VOMER\""." \"DB_SERVICE_NAME\" ";
                my $db_server_name = `$cmd`;
                if ( $db_server_name eq "") {
                        die "Could not get the DB SERVICE NAME ..!";
                }
                $db_server_name =~ s/SQLANYs_//g;
$cmd = "$rq query"." \"SOFTWARE\\Symantec\\VOMER\""." \"DB_DIR_NAME\" ";
                my $dbpath = `$cmd`;
                if ( $dbpath eq "") {
                        die "Could not get the DB DIR NAME ..!";
                }

 my $_mhinstalldir       = VRTS::Paths::get_path ("InstallDir");
 my $installdirmh        = File::Spec->canonpath ($_mhinstalldir);
 my $xbdadm = File::Spec->catfile   ($installdirmh, "bin", "xdbadm.exe");
 my $odbcini = File::Spec->catfile   ($dbpath,"conf", ".odbc");
 my $appdirconf = File::Spec->catdir   ($dbpath,"conf");
 my $username = "SAHARA";

 $cmd  = VRTS::Util::make_command($xbdadm,
                      "-g",
                      "-u",
                      $username,
                      "-o",
                      $odbcini,
                      "-c",
                      $appdirconf,
                      "-d",
                      "vomer");


 	my $PASSWORD=`$cmd`;
 	chomp($PASSWORD);

        my $DBF = File::Spec->catfile(File::Spec->catdir($dbpath),"vomer.db" );
	my $portnum = 14255;
        my $ConnParm = " ENG=$db_server_name\;".
                   "DBF=\"$DBF\"\;".
                   "ASTART=YES\;".
                   "ASTOP=YES\;".
                   "DBS=-m\;".
                   "UID=DBA\;".
                   "PWD=$PASSWORD\;";


        
	my $ASA_TOP_DIR = "$installdir\\asa11\\Bin64\\";
        $cmd = "\"${ASA_TOP_DIR}\dbisqlc.exe\" -q -c ${ConnParm} ${SQLFILE}";
        my $result = system ${cmd};

        print "\n";
        if ($result != 0) {
                print "Failed to execute the SQL File !\n";
				exit(0);
        } else {
                print "Executing the SQL File !\n";
        }
        print "\n";

}


##########################################################
# ER Cognos update (metamodel and reports) Code.
##########################################################


# After this step, Cognos is functional
sub updating_the_metamodel
{  
 my $COG_CONFIG;
 my $SAHARA_CPF;
 my $ACTION_XML;
 my $publish_all_log;
 my $COGNOS_PORT = 9400;
   my $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $vomadm,
                                                "vomessc",
                                                "--start",
						"Database");
   

my 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Could not execute  stop command Database");
	}
my $SSL_PASSWORD = 'cognos';
 wincognosconfig::win_init($cs,"something.engba.symantec.com");
 VRTS::ERConfig::log_write("Updating users within Cognos");

 wincognosconfig::get_user_details($conf_root_dir);
 wincognosconfig::load_package($COGNOS_PORT,$cs);

        print "Updating the Business views in metamodel ....";
       my $UPDATE_METAMODEL=$installdir . '\bin\update_metamodel.pl';
       my $CUSTOMATTRIBUTE=$installdir . '\bin\update_attributes.pl';
   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $UPDATE_METAMODEL,
                                                "-r");
   
#
 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Metamodel update failed..");
	}
#
   $cmd = VRTS::Util::make_command(File::Spec->catfile($perlbin,"perl.exe"),
                                                $CUSTOMATTRIBUTE,
                                                "-z 1");
   

 	$result = system${cmd};
	if ($result != 0) {
   	  VRTS::ERConfig::log_write(" Custom Attribute update failed..");
	}
	return $result;

}

 
##########################################################
# Import Reports in ES
##########################################################

sub import_reports
{  
	wincognosconfig::win_init($cs,"something.engba.symantec.com");
	VRTS::ERConfig::log_write("Deploying Reports...");
	wincognosconfig::deploy_reports(0);
}

#####################################################################################
# Clean up work directory
# This could be optional for most scenarios and is required only if JSPs get changed
#####################################################################################

sub delete_work_dir {

	my $vomersmwork = VRTS::VOMERPaths::get_apppath();
	if ( $vomersmwork eq "") {
	   die "No logs directory, exiting ..!";
	}

	my @dirs=($vomersmwork, 'sm', 'work');
	my $del_dir = File::Spec->catdir (@dirs);      
	if (-d $del_dir) {
	   rmtree($del_dir) or die "Unable to delete directory $del_dir";
	}

}

#####################################################################################
# Update Online Help
# This could be optional and is only required only if online help changes
#####################################################################################

sub update_OLH {

	my $docdir= File::Spec->catfile($installdir,"esmweb","webgui","symhelp","Content","EN_US");
	my $dstetlfile = File::Spec->catfile($HOTFIXDIR,"VOMAHELPCURRENT.tar.gz");	

	# Begin - Create an archive for existing docs directory
	my $cwd = getcwd();

	my $archdir=File::Spec->catdir ($docdir, "VOMAHELPCURRENT");
    my $targz = "VOMAHELPCURRENTBKUP.tar.gz";

	chdir $docdir;
	unlink($targz) if (-f $targz);
    my $file;

	chdir $archdir;
    my $tar = Archive::Tar->new;
    @tar_files = ();

    # get list of files and directories relative to this directory
    opendir (D, $archdir);
    my @files = readdir(D);
    closedir(D);

    foreach $file (@files)
    {
        next if ($file eq "." || $file eq "..");
        push @tar_files, $file;

        if (-d $file)
        {
            get_dir_listing($archdir, $file);
            chdir $archdir;
        }
    }

    chdir $archdir;
    $tar->add_files(@tar_files);

	chdir $docdir;
    if (! defined $tar->write( $targz, 9))
    {
         print "\n$targz TAR/GZ creation failed\n";
    }

    chdir $archdir;
	foreach $file (@tar_files)
    {
        if (-f $file)
        {
           unlink($file);
        }
        elsif(-d $file)
        {
           File::Path::rmtree($file);
        }
    }
	
	chdir($cwd);
	# End - Create an archive for existing docs directory

	# Extrack online help archive
	if (VRTS::OS->ungzip_and_untar($docdir, $dstetlfile))
	{
		print "\n Failed to extract";
	}

}

sub get_dir_listing
{
    my $base_dir = shift;
    my $dir = shift;
    my $rel_path;

    my $archdir = File::Spec->catdir ($base_dir, $dir);
    chdir $archdir;

    opendir (D, $archdir);
    my @files = readdir(D);
    closedir (D);
    foreach my $f (@files)
    {
        next if ($f eq "." || $f eq "..");
        $rel_path = File::Spec->catfile ($dir, $f);

        push (@tar_files, $rel_path);
        my $full_path =  File::Spec->catdir ( $base_dir, $dir, $f ); 
        if ( -d $full_path)
        {
            get_dir_listing ($base_dir, $rel_path);
        }
   }
}