package VRTS::VomAdm::Cmdlet::vomesgather;

use strict;
use Carp;
require Exporter;
use Getopt::Long;
use VRTS::CMD;
require VRTS::Paths;
require VRTS::Logger;
require VRTS::AddOnInfo;
require File::Spec;
require File::Basename;
use     CGI;


use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

@ISA = qw(Exporter);
@EXPORT = qw(new initialize check_env usage execute);
$VERSION = '4.0';


BEGIN
{
        my $installpath = "/opt/VRTSvomer/inst/perl";
        my $vomerperl;
        my $vomerpath;
        my $vomerbinpath;
        my $vomerlibasa;
        if ($^O =~ /Win32/i)
        {
                my $rq = &VRTS::CMD::REGQUERY;

my $cmd = "$rq query"." \"SOFTWARE\\Symantec\\VOMER\""." \"installdir\" ";
                my $dir = `$cmd`;
                chomp($dir);

                $installpath = $dir;
                $installpath = $installpath."\\inst\\perl";
                $vomerperl = $dir."\\lib\\perlmodules";
                $vomerpath = $dir."\\inst\\perl";
                $vomerbinpath = $dir."\\bin";
                $vomerlibasa = $dir."\\lib\\asa";
        }
        unshift @INC, $installpath;
        unshift @INC, $vomerperl;
        unshift @INC, $vomerpath;
        unshift @INC, $vomerbinpath;
        unshift @INC, $vomerlibasa;
}


use Getopt::Long;
#use VRTS::Paths;
use File::Path;
use File::Spec;
use File::Copy;
use VRTS::ERConfig; 
my $query = new CGI;
my $cs = $query->param("cs-hostname");

# valid command line options
my %ops =
(
  help => 1,
  gt => 1,
  s => 1 
);

my %opts;
my $operation = "";
my $directory_name = "";
my $installdir = "";
my @SYMLINKDIRS;
my @SYMLINKFILES;
 my $installdirmh = "";
my $dbpath = "";
my $appdirmh = "";
my $sourcename = "";
my $apppath = "";

sub new
{
    my $class = shift;
    my $vomadm = shift;
    my $self = {};
    
    $self->{vomadm} = $vomadm;
    bless ($self, $class);
    return $self;
}

sub initialize
{
    my $vomadm = shift;

    my $module = new VRTS::VomAdm::Cmdlet::vomesgather($vomadm);

    return $module;
}


sub execute
{
    my $self = shift;
    my $params = shift;


    if ($operation eq "help")
    {
        usage ();
        exit(0);
    }
    else 
    {
 	get_all()
    }
}

# validate parameters
# Voma command does not require VRTSsfmh pacakge to be 
# configured to any product.
sub check_env
{
     my $self = shift;


     my $ret = GetOptions(\%opts,qw (help gt=s s=s));
     foreach my $opr (keys %ops)
     {
         if (defined $opts{$opr})
         {
             $operation = $opr;
		  #print "operation $operation\n";
	     if ($operation eq "gt" ) {
                $directory_name = $opts{$operation};
	     }
	    if ($operation eq "s" ) {
                $sourcename = $opts{$operation};
		 if ($sourcename eq "") {
			die &usage(); 
 		}


         }
     }
     if (!defined $operation)
     {
         $self->{vomadm}->set_retcode(1);
         print STDERR "Invalid options\n";
         $self->usage ();
         return;
     }
}
}


sub usage{
   my $self = shift;
print "\nThis script is a supportability tool used for gathering \n".
"log's and data required for debugging  \n\n".
"vomadm vomesgather --gt <directoryname> [--s <sourcename>]\n\n".
" <sourcename>: Represents the rollup source name. By Default\n".
"source is not contacted to get debugging information, unless --s\n".
"option is used.    \n\n";

}


sub 
get_all {

  if ($directory_name eq "") {
	usage(); 
	return;
 }
 if ( ! -e $directory_name )
{
           eval {File::Path::mkpath($directory_name, 0, 755 );};
          if ($@) {
               die "Failed to Create the directory $directory_name   exiting..!";
          }

 }
# copy the log files
 copy_log();

}
sub
copy_log {

	my $username = "SAHARA";

                      my $rq = &VRTS::CMD::REGQUERY;
   my $cmd = "$rq query"." \"SOFTWARE\\Symantec\\VOMER\""." \"DB_SERVICE_NAME\" ";
                my $db_server_name = `$cmd`;
                if ( $db_server_name eq "") {
                        die "Could not get the DB SERVICE NAME ..!";
                }
                $db_server_name =~ s/SQLANYs_//g;
$cmd = "$rq query"." \"SOFTWARE\\Symantec\\VOMER\""." \"DB_DIR_NAME\" ";
                 $dbpath = `$cmd`;
                if ( $dbpath eq "") {
                        die "Could not get the DB DIR NAME ..!";
                }
$installdir        = VRTS::VOMERPaths::get_installpath();
 $apppath        = VRTS::VOMERPaths::get_apppath();
 my $vomalog       = File::Spec->catfile   ($apppath,"logs");
my $tvomalog = File::Spec->catfile($directory_name,"VRTSvomer","logs");

# Creating directories

 mkdir( File::Spec->catfile($directory_name,"VRTSvomer"), 0777 );
 mkdir( File::Spec->catfile($directory_name,"VRTSvomer","logs"), 0777 );
  mkdir( File::Spec->catfile($directory_name,"VRTSvomer","staging_area"), 0777 );

 mkdir( File::Spec->catfile($directory_name,"VRTSvomer","dblog"), 0777 );
# mkdir( File::Spec->catfile($directory_name,"VRTSvomer","db"), 0777 );
  mkdir( File::Spec->catfile($directory_name,"VRTSvomer","rollupsource"), 0777 );

 mkdir( File::Spec->catfile($directory_name,"VRTSsfmh"), 0777 );
 mkdir( File::Spec->catfile($directory_name,"VRTSsfmh","logs"), 0777 );


  my $stagingarea       = File::Spec->catfile   ($apppath,"staging_area");
my $tstaging_area = File::Spec->catfile($directory_name,"VRTSvomer","staging_area");

 my $dblog       = File::Spec->catfile($apppath,"dblog");
my $tdblog = File::Spec->catfile($directory_name,"VRTSvomer","dblog");
my $t1dblog = File::Spec->catfile($directory_name,"VRTSvomer","dblog","vomer.log");


my $_mhinstalldir       = VRTS::Paths::get_path ("InstallDir");
 $installdirmh        = File::Spec->canonpath ($_mhinstalldir);
my $_mhappdir           = VRTS::Paths::get_path ("AppDir");
$appdirmh            = File::Spec->canonpath ($_mhappdir);
my $appdirmhlog		= File::Spec->catfile($appdirmh,"logs");

my $tappdirmhlog = File::Spec->catfile($directory_name,"VRTSsfmh","logs");
 
 my $vomadm = File::Spec->catfile   ($installdirmh, "bin", "vomadm");
 my $vomerlog = File::Spec->catfile   ($dbpath,"db", "vomer.log");

 my $appdirconf= File::Spec->catdir   ($dbpath,"conf");
 my $tvomerlog = File::Spec->catfile($directory_name,"VRTSvomer","db");

my $tcogserver = File::Spec->catfile($installdir,"Cognos","logs");
my $tattrupdate = File::Spec->catfile($apppath,"attribute_updates.log");
my $updateattr = File::Spec->catfile($apppath,"update-attributes.log");


 print "Copying the log files \n";
 copy_files_recursively($vomalog,$tvomalog);
 copy_files_recursively($stagingarea,$tstaging_area);
 copy_files_recursively($dblog,$tdblog);
  copy_files_recursively($appdirmhlog,$tappdirmhlog);
  copy_files_recursively($vomerlog,$tvomerlog);
  copy_files_recursively($tcogserver,$tvomalog);
  copy($tattrupdate ,$tvomalog);
    copy($updateattr ,$tvomalog);

#  get the sahara_log ane message_log

     get_database_log();

my @backuplist = "";

add_dir_files($directory_name,\@backuplist);

 print "Creating the Archive .. \n";

  create_zip_file("vomesgather",\@backuplist);
}


sub create_zip_file
{
   my ($zipfile, $bkuplist) = @_;

  # my $zipfile = "test";
      my $list = File::Spec->catfile($directory_name, "$zipfile.list");
      
my ($drive, $rest) = split (/:/, $directory_name);
   my $bat = File::Spec->catfile($directory_name, "$zipfile.bat");

my $zipfile_name = File::Spec->catfile($directory_name, "$zipfile.zip");
   my $java = File::Spec->catfile($installdir, "esmweb", "jre", "bin", "java.exe");
   my $java_class_dir =  File::Spec->catdir($installdir, "tools");
   my $classpath="";

   if ( -e "ArchiveUtility.class" )
   { $classpath = cwd(); }
   else
   { $classpath = $java_class_dir; }

   open (H, "> $list");

   foreach my $file (@$bkuplist)
   {
     if ($file ne "" ) { 
       print H "$file\n";
	}
   }
   close(H);


   open (H, "> $bat");
   print H "$drive:\n";
   print H "\"$java\" -cp \"$classpath\" ArchiveUtility --archive \"$zipfile_name\" \"$list\"\n";
   close(H);
#  print "$zipfile_name";
   if ( -e "$zipfile_name" ) { 
	die " Archive file : $zipfile_name already exists. Please delete it manually before proceeding.. \n";
   }
  
  my $result = 		`$bat`; 
;
  if ($result != 0 ) {
	print "Data Archiving was not succesfull\n";
  } else {
    	print " Archiving succesfull. Zip file $zipfile_name located in : $directory_name \n";

  }
  unlink($bat);
}


sub get_database_log()
{
	my $perl_command = VRTS::ERConfig::get_perl_command();
 my $appdirconf= File::Spec->catdir   ($dbpath,"conf");
my $rmt_sql_file = File::Spec->catfile($apppath,"sahara.sql.$$");
my $msg_sql_file = File::Spec->catfile($apppath,"msg.sql.$$");
my $msg_out_file = File::Spec->catfile($directory_name,"VRTSvomer","dblog","message_log.txt");
my $saharaout = File::Spec->catfile($apppath,"saharaout.txt");
;

# Get the message log
    open (CONFIG, ">$msg_sql_file");
    print CONFIG "select *  from sahara.message_log;";
    close (CONFIG);
	
    my $vomadm = File::Spec->catfile( $installdirmh,"bin","vomadm");
	$msg_out_file =~ s/\\/\\\\/g;
	$msg_sql_file =~ s/\\/\\\\/g;
    my $cmd = VRTS::Util::make_command( $perl_command, $vomadm, 		"vomesdb",  "--f", $msg_sql_file,"--o",$msg_out_file);

    my $result = `$cmd`;
	if ($result != 0 ) {
		print "Could not get the message log ..\n";
  	}
	unlink($msg_sql_file);

# Get the rollup sources

	if ($sourcename eq "") {
	# return if no source name is given
		return;
 	}
      my $sourceoutputdir = File::Spec->catfile($directory_name,"VRTSvomer","rollupsource",$sourcename);

	 mkdir( $sourceoutputdir, 0777 );

	open (CONFIG, ">$rmt_sql_file");
    	print CONFIG "select table_name from systable where user_name(creator) = 'SAHARA' and table_name LIKE 'sahara_%' and table_type = 'BASE';";
	close (CONFIG);


   $cmd = VRTS::Util::make_command( $perl_command, $vomadm, "vomesdb", "--s",$sourcename, "--f", $rmt_sql_file,"--o",$saharaout);
      #print "$cmd";
	 my $result = `$cmd`;
	if ($result != 0 ) {
	   print "Could not get the sahara table for source : $sourcename continuing ..\n";
       unlink($rmt_sql_file);
	 unlink($saharaout);
	  return;
	 }
# Regardless unlink the files
  unlink($rmt_sql_file);


# Open the sahara table(s) from the given source
	open (DATA, "<$saharaout" ) or die " could not open the file  $!\n" ;
 	my @array_of_data = <DATA>;
 	close (DATA);
      unlink($saharaout);
	
	 open (NEWFILE, ">$rmt_sql_file");	
	 foreach my $line (@array_of_data) {    
	  chomp($line);
	   $line =~ s/\'//g;
	    my $sqlstmt = "select * from sahara.$line;\n";
    	    print NEWFILE $sqlstmt;
	    my $outputfile = "$sourceoutputdir\\$line.txt";
    	    print NEWFILE "output to \"$outputfile\" FORMAT ASCII;\n";
 	}

	   $cmd = VRTS::Util::make_command( $perl_command, $vomadm, "vomesdb", "--s",$sourcename, "--f", $rmt_sql_file);
	      #print "$cmd";
	 $result = `$cmd`;
	if ($result != 0 ) {
	   print "Could not get the sahara table for source : $sourcename continuing ..\n";      	  
	 }
# Regardless unlink the files
	unlink($rmt_sql_file); 
}




sub add_dir_files
{
  my ($dir, $bkuplist) = @_;
  # VRTS::Logger::log ( 'debug', "add_dir_files:$dir" ); 
  if ( -l $dir )
  { 
      if ($^O =~ /Win32/i)
      { 
        # print " push symbolic link $dir \n";

        push(@$bkuplist,$dir);         
      } 
  }
  else
  {
     if ($^O =~ /Win32/i)
     { 
        # In windows, symbolic link check "-l" is not able to detect symlinks.
        # So store SYMLINKS in @SYMLINKDIRS

        foreach my $symdir (@SYMLINKDIRS)
        {
          if ( $dir eq $symdir )
          { 
	     # print "$dir is a symbolic link\n";
	     return; 
	  } 
        }
     }

     # print "$dir is a not symbolic link\n";
  }
    
  if ( ! opendir (DIR, $dir) )
  {
    return;
  } 

  my @contents ;

  if ($^O =~ /Win32/i)
  { @contents = map "$dir\\$_", sort grep !/^\.\.?$/, readdir DIR; }
  else
  { @contents = map "$dir/$_", sort grep !/^\.\.?$/, readdir DIR; }
  closedir DIR;

  foreach (@contents) {
      chomp($_);

      # symbolic file,
      if ($^O =~ /Win32/i)
      { 
	 my $flag=0;
         foreach my $symfile (@SYMLINKFILES)
         {
           if ( $_ eq $symfile )
           { 
             # print "$_ is a symbolic link\n";
	     $flag = 1;
             next; 
           } 
         }
	 if ( $flag == 1 )
	 { next; }
      }

      if ( (! -l $_) &&  ( !-d $_ ) && ($_ !~ /\.java_pid/) && ($_ !~ /jar_cache/) && 
           ($_ !~ /\.swp$/) && ($_ !~ /lrm_socket/) && ($_ !~ /__SQLAny__/) )
      { push(@$bkuplist,$_); }

      next unless -l || -d; 
      &add_dir_files($_, $bkuplist);
  }
}

sub copy_files_recursively
{

  my ($source, $dest) = @_;
  
 # get the contents of the directory.
        opendir(D, $source);
        my @f = readdir(D);
        closedir(D);
        # recurse through the directory structure and copy files.
        foreach my $file (@f) {
        # Setup the full path to the source and dest files.
                my $filename = $source . "\\" . $file;
            my $destfile = $dest . "\\" . $file;
                # get the file info for the 2 files.
            my $sourceInfo = stat( $filename );
                my $destInfo = stat( $destfile );

            # make sure the destination directory exists.
                mkdir( $dest, 0777 );
                if ($file eq '.' || $file eq '..') {
                } elsif (-d $filename) { 
                copy_files_recursively($filename, $destfile);
                } else {
                        if(-e $destfile){
                                unlink("$destfile") || print "Error deleting
 existing file $destfile";
                        }
                  copy( $filename, $destfile ) or print "Error copying$filename : $!";
                }
        }
}
1;
